diff -NrU2 vqcc-gtk-0.5/src/gui_msg.c vqcc-gtk-0.5.1-shaman5/src/gui_msg.c
--- vqcc-gtk-0.5/src/gui_msg.c	2005-01-06 13:16:08.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/gui_msg.c	2005-06-28 22:33:41.000000000 +0400
@@ -28,4 +28,9 @@
 #include <gdk/gdkkeysyms.h>
 
+#include <gdk/gdkx.h>
+#include <X11/Xatom.h>
+#include <X11/Xlib.h>
+#include <X11/Xutil.h>
+
 #include "main.h"
 #include "gui.h"
@@ -37,4 +42,5 @@
 #include "sess.h"
 
+
 #define HAVE_EXPANDER_WIDGET \
 	((GTK_MAJOR_VERSION > 2) || ((GTK_MAJOR_VERSION==2) && (GTK_MINOR_VERSION>=4)))
@@ -50,7 +56,11 @@
 	GtkWidget	* window_w;
 	GtkWidget	* text_w;
+	GtkWidget 	* userlist;
+	GtkListStore * ulist_model;
 	GtkWidget	* send_w, * reply_w, * quote_w;
+	
 #if(HAVE_EXPANDER_WIDGET)
 	GtkWidget	* option_expander_w,
+				* option_user_expander_w,
 			* option_save_size_w, * option_ctrl_enter_w;
 #endif
@@ -60,4 +70,6 @@
 #define PMESSAGE_INFO(p) ((struct message_info*)p)
 
+
+
 /** static variables
   *****************************************/
@@ -68,4 +80,24 @@
   ***************************************/
 
+/*Set window manager "Urgent" hint*/
+static void
+handle_urgent(struct message_info * mi, gboolean add)
+{
+        XWMHints *hints;
+        GtkWidget *gtkwin = GTK_WINDOW(mi->window_w);
+
+        g_return_if_fail(gtkwin != NULL);
+        g_return_if_fail(gtkwin->window != NULL);
+
+        hints = XGetWMHints(GDK_WINDOW_XDISPLAY(gtkwin->window), GDK_WINDOW_XWINDOW(gtkwin->window));
+        if (add)
+                hints->flags |= XUrgencyHint;
+        else
+                hints->flags &= ~XUrgencyHint;
+        XSetWMHints(GDK_WINDOW_XDISPLAY(gtkwin->window),
+                    GDK_WINDOW_XWINDOW(gtkwin->window), hints);
+        XFree(hints);
+}
+
 /* message_init:
  *	initializes message list
@@ -86,6 +118,7 @@
 {
 	g_assert(mi && mi->remote_user_name);
-
+	
 	if(destroy_widget) {
+		gui_ulist_free((GtkListStore *)mi->ulist_model);
 		g_assert(mi->window_w);
 		gtk_widget_destroy(mi->window_w);
@@ -94,5 +127,5 @@
 	g_free(mi->remote_user_name);
 	g_free(mi);
-
+	
 	/* remove message struct from the list */
 	msg_list = g_list_remove(msg_list, mi);
@@ -127,34 +160,72 @@
 		orig = g_utf8_next_char(orig);
 	}
-
-	if(*prev_c != '\n') {
+	/*Now answer text will be at top of message*/
+	/*if(*prev_c != '\n') {
 		g_string_append_c(quoted, '\n');
-	}
-
+	}*/
+	
+	g_string_prepend_c(quoted, '\n');
 	return quoted;
 }
 
+
+/*moved to util.h
+enum user_list_column_enum {
+	COLUMN_ICON,
+	COLUMN_NICKNAME,
+	COLUMN_USER_PTR,
+	
+	COLUMN_NUM
+};
+*/
+
+
 static void
 message_send(struct message_info * mi)
 {
 	GtkTextIter si, ei;
-	gpointer event_v[2];
+	gpointer event_v[3];
+	GtkTreeIter i;
+	//gpointer iter_user;
+	GValue v = {0,};
+	GValue sel = {0,};
 
-	if(mi->remote_user_id) {
+	if(mi->remote_user_id!=NULL){
 		/* "send" */
 		gtk_text_buffer_get_start_iter(mi->buffer, &si);
 		gtk_text_buffer_get_end_iter(mi->buffer, &ei);
-
-		/* send net message to the user */
-		EVENT_V(event_v,0) = mi->remote_user_id;
-		EVENT_V(event_v,1) = gtk_text_buffer_get_text(mi->buffer, &si, &ei, TRUE);
-		raise_event(EVENT_MESSAGE_SEND, event_v, 0);
-		g_free(EVENT_V(event_v,1));
-
+		if(gtk_tree_model_get_iter_first(GTK_TREE_MODEL(mi->ulist_model), &i)) {
+			do {
+				gtk_tree_model_get_value(GTK_TREE_MODEL(mi->ulist_model), &i,
+					COLUMN_SELECTED, &sel);
+				gtk_tree_model_get_value(GTK_TREE_MODEL(mi->ulist_model), &i,
+					COLUMN_USER_PTR, &v);
+
+				if(g_value_get_boolean(&sel)&&(g_value_get_pointer(&v)!=NULL)){
+				/* send net message to the user */
+
+					EVENT_V(event_v,0) =  g_value_get_pointer(&v);
+					EVENT_V(event_v,1) = gtk_text_buffer_get_text(mi->buffer, &si, &ei, TRUE);
+		
+					if ((mi->my==TRUE) && (mi->mass_message==TRUE))
+						EVENT_V(event_v,2) = TRUE;
+					else
+						EVENT_V(event_v,2) = FALSE;
+		
+					raise_event(EVENT_MESSAGE_SEND, event_v, 0);
+					g_free(EVENT_V(event_v,1));
+				}
+				g_value_unset(&v);
+				g_value_unset(&sel);
+		
+			} while((gtk_tree_model_iter_next(GTK_TREE_MODEL(mi->ulist_model), &i)));
+		}
+	}
 		/* delete this message */
 		message_delete(mi, TRUE);
-	}
 }
 
+
+
 /* message_turn_into_my:
  *	changes the message so the user can
@@ -187,5 +258,10 @@
 	if(quoted)
 		g_string_free(quoted, TRUE);
-
+	
+	gtk_text_buffer_get_start_iter(mi->buffer, &start);
+	gtk_text_buffer_place_cursor(mi->buffer,&start);
+	
+	
+	
 	/* hide reply/quote buttons and emerge send one */
 	gtk_widget_hide(mi->reply_w);
@@ -230,4 +306,16 @@
 }
 
+
+/*Unset window manager "Urgent" hint */
+static gboolean
+message_cb_focus_change_event(
+	GtkWidget * widget, GdkEventFocus * focus_event, struct message_info * mi)
+{
+	gboolean focus_state = focus_event->in!=0;
+	if(focus_state)
+		handle_urgent(mi,FALSE);	
+	return FALSE;
+}
+
 /* message_cb_delete_event:
  *	gets notified if the user tries to close the message dialog
@@ -343,4 +431,7 @@
 }
 
+
+
+
 /* message_make_window:
  *	build up and show GTK+ dialog for the message specified (mi)
@@ -349,8 +440,10 @@
 message_make_window(struct message_info * mi, const gchar * preset_text)
 {
-	GtkWidget * b, * w, * option_vbox;
+	GtkWidget * b, * main_box, * w, * option_vbox;
 	gchar * title;
 	gint dlg_width, dlg_height;
-
+	gboolean HaveFocus;
+	GList * l;
+	
 	g_assert(mi && mi->remote_user_id && mi->remote_user_name);
 
@@ -366,4 +459,5 @@
 #endif
 		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
+	gtk_window_set_type_hint(GTK_WINDOW(mi->window_w),GDK_WINDOW_TYPE_HINT_NORMAL);	
 	g_free(title);
 	gui_misc_set_icon_for(GTK_WINDOW(mi->window_w));
@@ -373,4 +467,6 @@
 	}
 
+
+	
 	/* add send/quote/reply buttons */
 	mi->quote_w = gtk_dialog_add_button(
@@ -394,7 +490,21 @@
 		G_OBJECT(mi->window_w), "response",
 		G_CALLBACK(message_cb_response), (gpointer)mi);	
-
+	g_signal_connect(G_OBJECT(mi->window_w), "focus-in-event",
+		G_CALLBACK(message_cb_focus_change_event), (gpointer)mi);
+		
+		
+		
+	/* create horizontal paned */
+	main_box = gtk_hpaned_new();
+	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(mi->window_w)->vbox), main_box, TRUE, TRUE, 0);
+	
+	/*if my massmessage then show user list*/
+	if(mi->my && mi->mass_message)
+		gtk_paned_set_position((GtkPaned *) main_box,dlg_width-200);
+	else
+		gtk_paned_set_position((GtkPaned *) main_box,dlg_width);
+	
 	b = gtk_vbox_new(FALSE, 2);
-	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(mi->window_w)->vbox), b);
+	gtk_container_add(GTK_CONTAINER(main_box), b);
 
 	w = gtk_scrolled_window_new(NULL, NULL);
@@ -442,8 +552,16 @@
 #endif
 
+	/*Add user list*/
+	mi->ulist_model=(GtkListStore *)gui_ulist_create_model(TRUE);
+	mi->userlist=(GtkWidget *)gui_ulist_create(mi->ulist_model,TRUE,((mi->my &&
+							mi->mass_message)? NULL : mi->remote_user_id ));
+	gtk_container_add(GTK_CONTAINER(main_box), mi->userlist);
+	
+	
 	/*
 	 * Disable `Send' button so the user cant send message if the receiver
 	 * cannot or will refuse to receive the message.
 	 */
+	if(mi->my) 
 	gtk_widget_set_sensitive(
 		mi->send_w,
@@ -464,5 +582,35 @@
 		gtk_widget_hide(mi->send_w);
 	}
+	
+	/*test have any editable window focus?*/
+	HaveFocus=FALSE;
+	struct message_info * mi_tmp;
+	for(l = msg_list; l; l = l->next) {
+		mi_tmp=((struct message_info *)l->data);
+		if( GTK_WIDGET_HAS_FOCUS(mi_tmp->text_w)
+			&&gtk_text_view_get_editable(GTK_TEXT_VIEW(mi_tmp->text_w)) ){
+			HaveFocus=TRUE;
+			break;
+		}
+	}
+	
+	if(
+		(  (!mi->my)&&(prefs_bool(PREFS_GUI_MSG_MINIMIZE_PRIVATE_MESSAGES)||
+		(HaveFocus))&&(!mi->mass_message)  )
+		||(  (!mi->my)&&prefs_bool(PREFS_GUI_MSG_MINIMIZE_MASS_MESSAGES)
+		&&(mi->mass_message)  )
+		)
+			gtk_window_iconify(GTK_WINDOW(mi->window_w));			
+			
+		
+	
 	gtk_window_present(GTK_WINDOW(mi->window_w));
+	
+	if(
+		(  (!mi->my)&&(prefs_bool(PREFS_GUI_MSG_MINIMIZE_PRIVATE_MESSAGES)||
+		(HaveFocus))&&(!mi->mass_message)  )
+		||(  (!mi->my)&&prefs_bool(PREFS_GUI_MSG_MINIMIZE_MASS_MESSAGES)
+		&&(mi->mass_message)  )
+		)	handle_urgent(mi,TRUE);
 }
 
@@ -496,8 +644,12 @@
 	/* make and show up message window */
 	message_make_window(mi, text);
-
+	
+	//if (my)
+	//	gtk_window_present(GTK_DIALOG(mi->window_w));
 	return mi;
 }
 
+
+
 /* message_cleanup:
  *	deletes all the messages and all the allocated
@@ -672,4 +824,8 @@
 		prefs_register(PREFS_GUI_MSG_MAX_WINDOWS, PREFS_TYPE_UINT,
 			_("Maximum message windows"), NULL, NULL);
+		prefs_register(PREFS_GUI_MSG_MINIMIZE_PRIVATE_MESSAGES, PREFS_TYPE_BOOL,
+			_("Minimize received private messages"), NULL, NULL);
+		prefs_register(PREFS_GUI_MSG_MINIMIZE_MASS_MESSAGES, PREFS_TYPE_BOOL,
+			_("Minimize received mass messages"), NULL, NULL);
 		prefs_register(PREFS_GUI_MSG_CTRL_ENTER, PREFS_TYPE_BOOL,
 			_("CTRL-Enter sends message"), NULL, NULL);
@@ -705,4 +861,7 @@
 		message_new(v, TRUE, FALSE, NULL);
 		break;
+	case EVENT_IFACE_USER_MASS_MESSAGE_REQ:
+		message_new(v, TRUE, TRUE, NULL);
+		break;
 	case EVENT_NET_MSG_MESSAGE:
 		message_net_msg(
@@ -729,3 +888,2 @@
 		EVENT_MAIN|EVENT_IFACE|EVENT_USER|EVENT_NET);
 }
-
diff -NrU2 vqcc-gtk-0.5/src/gui_msg.h vqcc-gtk-0.5.1-shaman5/src/gui_msg.h
--- vqcc-gtk-0.5/src/gui_msg.h	2005-01-06 13:16:09.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/gui_msg.h	2005-04-13 17:38:06.000000000 +0400
@@ -25,4 +25,6 @@
 /* preferences registered in the `gui_msg' module */
 #define PREFS_GUI_MSG_IN_WINDOW		"gui/msg/in_window"
+#define PREFS_GUI_MSG_MINIMIZE_PRIVATE_MESSAGES		"gui/msg/minimize_private_messages"
+#define PREFS_GUI_MSG_MINIMIZE_MASS_MESSAGES		"gui/msg/minimize_mass_messages"
 #define PREFS_GUI_MSG_SUGGESTED_SIZE	"gui/msg/suggested_size"
 #define PREFS_GUI_MSG_MAX_WINDOWS	"gui/msg/max_windows"
@@ -33,3 +35,2 @@
 
 #endif /* #ifndef GUI_MSG_H__ */
-
diff -NrU2 vqcc-gtk-0.5/src/gui_ulist.c vqcc-gtk-0.5.1-shaman5/src/gui_ulist.c
--- vqcc-gtk-0.5/src/gui_ulist.c	2004-12-23 22:40:00.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/gui_ulist.c	2005-06-27 21:05:59.000000000 +0400
@@ -50,14 +50,5 @@
 #define ULIST_ACTIVE(user)	(user ? user_is_active(user): gui_is_active())
 
-enum user_list_column_enum {
-	COLUMN_ICON,
-	COLUMN_NICKNAME,
-	COLUMN_USER_PTR,
-	COLUMN_NUM
-};
 
-/** static vars
-  **********************************************/
-static GtkListStore	* ulist_model;
 
 /* user info tip */
@@ -72,4 +63,10 @@
 static GdkPoint		info_tip_pos;
 
+/** static vars
+  **********************************************/
+//static GtkListStore	* ulist_model;
+static GList * ulist_model_list;
+static int ulist_model_count;
+
 /** static routines
   **********************************************/
@@ -92,4 +89,13 @@
 
 static void
+user_menu_mass_send_cb(GtkMenuItem * item, GtkMenuShell * menu)
+{
+	gpointer user = user_by_name(g_object_get_data(G_OBJECT(menu), "username"));
+	if(user!=NULL)
+	raise_event(EVENT_IFACE_USER_MASS_MESSAGE_REQ, user, 0);
+}
+
+
+static void
 user_menu_beep_cb(GtkMenuItem * item, GtkMenuShell * menu)
 {
@@ -165,4 +171,10 @@
 	gtk_menu_shell_append(menu, item_w);
 
+	/* "Send mass message" */
+	item_w = util_image_menu_item(
+		GUI_STOCK_SEND_MESSAGE, _("<b>Send mass message</b>"),
+		G_CALLBACK(user_menu_mass_send_cb), menu);
+	gtk_menu_shell_append(menu, item_w);	
+	
 	/* "Beep" */
 	item_w = util_image_menu_item(NULL, _("Beep"), G_CALLBACK(user_menu_beep_cb), menu);
@@ -415,4 +427,22 @@
 }
 
+/*Toggle user*/
+static void
+check_user_cb(GtkCellRendererToggle *renderer, gchar *path_str, gpointer data)
+{
+	GtkTreeIter iter;
+	gboolean check_user;
+
+		gtk_tree_model_get_iter_from_string(GTK_TREE_MODEL(data), &iter, path_str);
+		gtk_tree_model_get((GtkListStore *)GTK_TREE_MODEL(data), &iter,
+					   COLUMN_SELECTED, &check_user,
+					   -1);
+	
+		gtk_list_store_set((GtkListStore *)GTK_TREE_MODEL(data), &iter,
+					   COLUMN_SELECTED, !check_user,
+					   -1);
+}
+
+
 /* info_tip_set_content_for_me
  *	create info tip content for ourselves
@@ -471,7 +501,13 @@
 	time_t last_time_active;
 
+	
+	/* add user ip */
+	escaped = g_markup_escape_text( inet_ntoa( htonl(user_ip_of(user_id)) ), -1);
+	g_string_printf(markup, "<b><u>ip: %s</u></b>", escaped);
+	g_free(escaped);
+
 	/* add user name */
 	escaped = g_markup_escape_text(user_name_of(user_id), -1);
-	g_string_printf(markup, "<big><b><u>%s</u></b></big>", escaped);
+	g_string_append_printf(markup, "\n<big><b><u>%s</u></b></big>", escaped);
 	g_free(escaped);
 
@@ -543,7 +579,12 @@
 	gchar * escaped;
 
+	/* add user ip */
+	escaped = g_markup_escape_text( inet_ntoa( htonl(user_ip_of(user_id)) ), -1);
+	g_string_printf(markup, "<b><u>ip: %s</u></b>", escaped);
+	g_free(escaped);
+	
 	/* add user name */
 	escaped = g_markup_escape_text(user_name_of(user_id), -1);
-	g_string_printf(markup, "<big><b><u>%s</u></b></big>", escaped);
+	g_string_append_printf(markup, "\n<big><b><u>%s</u></b></big>", escaped);
 	g_free(escaped);
 
@@ -719,7 +760,10 @@
 		if(cell_found) {
 			/* get user of the focused cell */
-			gtk_tree_model_get_iter(GTK_TREE_MODEL(ulist_model), &cell_iter, cell_path);
+			GtkListStore	* model;
+			model = gtk_tree_view_get_model(treeview_w);
+			gtk_tree_model_get_iter((GtkTreeModel *)GTK_TREE_MODEL(model),
+				(GtkTreeIter *) &cell_iter,(GtkTreePath *) cell_path);
 			gtk_tree_model_get(
-				GTK_TREE_MODEL(ulist_model), &cell_iter,
+				GTK_TREE_MODEL(model), &cell_iter,
 				COLUMN_USER_PTR, &info_tip_user, -1);
 
@@ -763,5 +807,6 @@
 	const char * user_name,
 	enum user_mode_enum mode,
-	GtkTreeIter * where)
+	GtkTreeIter * where,
+	GtkListStore * ulist_model)
 {
 	gboolean valid;
@@ -795,6 +840,12 @@
 {
 	GtkTreeIter iter;
+	GList * l;
+	GtkListStore * ulist_model;
+
 
-	ulist_where_to_insert(ULIST_NAME(user), ULIST_MODE(user), &iter);
+	for(l = ulist_model_list; l; l = l->next) {
+	ulist_model = ((GtkListStore *)l->data);
+		
+	ulist_where_to_insert(ULIST_NAME(user), ULIST_MODE(user), &iter, ulist_model);
 	gtk_list_store_set(
 		ulist_model, &iter,
@@ -803,12 +854,11 @@
 		COLUMN_USER_PTR, user,
 		-1);
+	}//for
 }
 
 static gboolean
-ulist_iter_by_user(gpointer user, GtkTreeIter * iter)
+ulist_iter_by_user(gpointer user, GtkTreeIter * iter,GtkListStore * ulist_model)
 {
 	gpointer iter_user;
-
-	g_assert(iter);
 	
 	if(gtk_tree_model_get_iter_first(GTK_TREE_MODEL(ulist_model), iter)) {
@@ -827,7 +877,14 @@
 {
 	GtkTreeIter iter;
+	GList * l;
+	GtkListStore * ulist_model;
 
-	if(ulist_iter_by_user(user, &iter))
+
+	for(l = ulist_model_list; l; l = l->next) {
+	ulist_model = ((GtkListStore *)l->data);
+		
+	if(ulist_iter_by_user(user, &iter, ulist_model))
 		gtk_list_store_remove(ulist_model, &iter);
+	}//for
 }
 
@@ -836,6 +893,12 @@
 {
 	GtkTreeIter iter;
+	GList * l;
+	GtkListStore * ulist_model;
 
-	if(ulist_iter_by_user(user, &iter)) {
+
+	for(l = ulist_model_list; l; l = l->next) {
+	ulist_model = ((GtkListStore *)l->data);
+		
+	if(ulist_iter_by_user(user, &iter, ulist_model)) {
 		gtk_list_store_set(
 			ulist_model, &iter,
@@ -843,4 +906,5 @@
 		       	-1);
 	}
+	}//for
 }
 
@@ -915,14 +979,32 @@
  ******************************************/
 
+
+GtkListStore *
+gui_ulist_create_model(gboolean ismessage)
+{
+GtkListStore *ulist_model;
+	if(!ismessage)
+	ulist_model = gtk_list_store_new(3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_POINTER);
+	else
+	ulist_model = gtk_list_store_new(4, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_BOOLEAN);
+return ulist_model;
+}
+
 /* gui_ulist_create:
  *	creates & setups new userlist widget
  *	and static variables
  */
+
+/*shaman this is wrong but i don't know how to write better*/
 GtkWidget *
-gui_ulist_create()
+gui_ulist_create(GtkListStore *ulist_model,gboolean ismessage,gpointer user_id)
 {
-	GtkWidget * treeview_w, * scrolled_w;
+	GtkWidget * treeview_w;//, * scrolled_w;
 	GtkCellRenderer * icon_renderer;
-	
+	GtkListStore * ulist_model_tmp;
+	GtkCellRenderer *renderer;
+	GtkWidget *scrolled_w;
+	info_tip_destroy();
+		
 	/* initialize misc variables
 	 */
@@ -934,6 +1016,11 @@
 
 	/* create list store */
+/*	if(!ismessage)
 	ulist_model = gtk_list_store_new(3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_POINTER);
+	else
+	ulist_model = gtk_list_store_new(4, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_BOOLEAN);
+	*/
 	
+
 	/* create scrolled window & tree view widget */
 	scrolled_w = gtk_scrolled_window_new(NULL, NULL);
@@ -941,5 +1028,6 @@
 		GTK_SCROLLED_WINDOW(scrolled_w),
 		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
-
+	
+	
 	treeview_w = gtk_tree_view_new();
 	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(treeview_w), FALSE);
@@ -960,4 +1048,44 @@
 		GTK_TREE_VIEW(treeview_w), -1, NULL,
 		gtk_cell_renderer_text_new(), "text", COLUMN_NICKNAME, NULL);
+		
+	if(ismessage){
+	renderer = gtk_cell_renderer_toggle_new();
+	g_signal_connect(G_OBJECT(renderer), "toggled",
+			 G_CALLBACK(check_user_cb), ulist_model);
+		
+	gtk_tree_view_insert_column_with_attributes(
+		GTK_TREE_VIEW(treeview_w), 0, NULL,
+		renderer, "active", COLUMN_SELECTED, NULL);
+		
+		ulist_model_tmp=(GtkListStore *)g_list_first(ulist_model_list)->data;
+		GValue v = {0,};
+		GtkTreeIter i,i2;
+		gboolean select_it;
+		
+		if( gtk_tree_model_get_iter_first(GTK_TREE_MODEL(ulist_model_tmp), &i) ){
+			do{
+				gtk_tree_model_get_value(GTK_TREE_MODEL(ulist_model_tmp),
+					&i, COLUMN_USER_PTR, &v);
+				select_it=FALSE;
+				gtk_list_store_append (ulist_model, &i2);	
+				
+				if((user_id==NULL)||(user_id!=NULL && user_id==g_value_get_pointer(&v)))
+					select_it=TRUE;
+
+				gtk_list_store_set(
+					ulist_model, &i2,
+					COLUMN_ICON,
+					util_user_state_stock(ULIST_MODE(g_value_get_pointer(&v)),
+					ULIST_ACTIVE(g_value_get_pointer(&v))),
+					COLUMN_NICKNAME, ULIST_NAME(g_value_get_pointer(&v)),
+					COLUMN_USER_PTR, g_value_get_pointer(&v),
+					COLUMN_SELECTED,select_it,
+					-1);	
+					
+				g_value_unset(&v);
+			}while(gtk_tree_model_iter_next(GTK_TREE_MODEL(ulist_model_tmp), &i));
+		}//if
+		
+	}else{
 
 	/* connect signals */
@@ -972,6 +1100,16 @@
 	g_signal_connect(G_OBJECT(treeview_w),
 			"popup-menu", G_CALLBACK(ulist_popup_menu_cb), NULL);
+	}
+	
+//	if(ismessage){
+//	}//if ismessage
+	
+	/* add new model to the list */
+	ulist_model_list = g_list_prepend(ulist_model_list, ulist_model);
+	++ulist_model_count;
 
+//ulist_model=NULL;
 	return scrolled_w;
+	//return MyUlist;
 }
 
@@ -979,6 +1117,8 @@
  *	frees any static data unreferenced in GtkWidget
  */
-void gui_ulist_free()
+void gui_ulist_free(GtkListStore * ulist_model)
 {
+	ulist_model_list = g_list_remove(ulist_model_list, ulist_model);
+	--ulist_model_count;
 }
 
@@ -988,7 +1128,9 @@
 void gui_ulist_register()
 {
+	ulist_model_list = NULL;
+	ulist_model_count = 0;
+	
 	register_event_cb(
 		ulist_event_cb,
 		EVENT_MAIN | EVENT_USER | EVENT_NET | EVENT_IFACE);
 }
-
diff -NrU2 vqcc-gtk-0.5/src/gui_ulist.h vqcc-gtk-0.5.1-shaman5/src/gui_ulist.h
--- vqcc-gtk-0.5/src/gui_ulist.h	2004-09-21 16:37:48.000000000 +0400
+++ vqcc-gtk-0.5.1-shaman5/src/gui_ulist.h	2005-04-13 19:27:11.000000000 +0400
@@ -22,9 +22,9 @@
 #ifndef GUI_ULIST_H__
 #define GUI_ULIST_H__
-
+GtkListStore * gui_ulist_create_model();
 GtkWidget * gui_ulist_create();
 void gui_ulist_free();
 void gui_ulist_register();
+static GtkListStore * main_ulist_model;
 
 #endif /* #ifndef GUI_ULIST_H__ */
-
diff -NrU2 vqcc-gtk-0.5/src/libqcproto/link.c vqcc-gtk-0.5.1-shaman5/src/libqcproto/link.c
--- vqcc-gtk-0.5/src/libqcproto/link.c	2004-12-22 20:51:04.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/libqcproto/link.c	2005-06-28 19:03:00.000000000 +0400
@@ -284,9 +284,11 @@
 	const qcs_msg * msg )
 {
+	
 	char * datagram;
 	ssize_t datagram_len, datagram_sent;
 	struct sockaddr_in sab;
 	link_data * link = (link_data *)link_id;
-
+	
+	
 	// check link
 	if(!VALID_ID(link_id)) ERRRET(EINVAL);
@@ -296,4 +298,5 @@
 	switch(link->proto) {
 	case QCS_PROTO_VYPRESS:
+		
 		datagram = qcs__make_vypress_msg(msg, &datagram_len);
 		break;
@@ -305,19 +308,22 @@
 		break;
 	}
+	
 	if(datagram==NULL)
 		ERRRET(EINVAL);
-
 	sab.sin_family = PF_INET;
-	sab.sin_port = htons(link->port);
-	sab.sin_addr.s_addr = htonl(link->broadcast_addr);
+	sab.sin_port = htons(link->port); 
+	sab.sin_addr.s_addr =(msg->broadcast==1 || msg->src_ip==0)? htonl(link->broadcast_addr): htonl(msg->src_ip);
 	datagram_sent = sendto(
 		link->tx, datagram, datagram_len, 0,
 		(struct sockaddr*)&sab, sizeof(sab));
 
-	free(datagram);
+	
 
-	if(datagram_sent != datagram_len)
+	if(datagram_sent != datagram_len){
+		printf("net error to ip: %d  %d    %s           %s\n ",msg->broadcast ,msg->src_ip , inet_ntoa( htonl(msg->src_ip)  ) , datagram);
+		free(datagram);
 		ERRRET(ENETUNREACH);
-
+	}
+	free(datagram);
 	return 1;
 }
@@ -391,4 +397,6 @@
 	msg->umode = QCS_UMODE_INVALID;
 	msg->uactive = 1;
+	msg->broadcast = 0;
+	msg->src_ip=0;
 	msg->src = msg->dst = msg->text = msg->supp = msg->chan = NULL;
 
@@ -399,5 +407,5 @@
 {
 	if(msg==NULL) return;
-
+	
 	if( msg->src ) free( msg->src );
 	if( msg->dst ) free( msg->dst );
diff -NrU2 vqcc-gtk-0.5/src/libqcproto/p_qchat.c vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_qchat.c
--- vqcc-gtk-0.5/src/libqcproto/p_qchat.c	2004-12-22 20:51:04.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_qchat.c	2005-06-28 19:48:06.000000000 +0400
@@ -47,5 +47,5 @@
 char *
 qcs__make_qchat_msg(
-	const qcs_msg * msg,
+	qcs_msg * msg,
 	ssize_t * pmsg_len )
 {
@@ -66,4 +66,5 @@
 		ADDCHAR('0');
 		ADDSTR(msg->src);
+		msg->broadcast = 1;
 		break;
 	case QCS_MSG_REFRESH_ACK:
@@ -80,4 +81,5 @@
 		ADDSTR(msg->src);
 		ADDSTR(msg->text);
+	    msg->broadcast=1;
 		break;
 	case QCS_MSG_CHANNEL_JOIN:
@@ -87,4 +89,5 @@
 		ADDCHAR(qcs__net_qcumode(msg->umode));
 		ADDCHAR('0');		/* unknown purpose !! */
+	    msg->broadcast=1;
 		break;
 	case QCS_MSG_CHANNEL_LEAVE:
@@ -93,4 +96,5 @@
 		ADDCHAN(msg->chan);
 		ADDCHAR('0');		/* unknown */
+	    msg->broadcast=1;
 		break;
 	case QCS_MSG_CHANNEL_ME:
@@ -99,4 +103,5 @@
 		ADDSTR(msg->src);
 		ADDSTR(msg->text);
+		msg->broadcast=1;
 		break;
 	case QCS_MSG_MESSAGE_ACK:
@@ -125,4 +130,5 @@
 		ADDSTR(msg->text);
 		ADDCHAR('0');		/* unknown */
+		msg->broadcast=1;
 		break;
 	case QCS_MSG_MODE_CHANGE:
@@ -131,4 +137,5 @@
 		ADDCHAR(qcs__net_qcumode(msg->umode));
 		ADDCHAR('0');		/* unknown */
+		msg->broadcast=1;
 		break;
 	case QCS_MSG_ACTIVE_CHANGE:
@@ -136,4 +143,5 @@
 		ADDSTR(msg->src);
 		ADDCHAR(qcs__net_qcuactive(msg->uactive));
+		msg->broadcast=1;
 		break;
 	case QCS_MSG_TOPIC_REPLY:
@@ -160,4 +168,5 @@
 		ADDCHAR('B');
 		ADDSTR(msg->text);
+		msg->broadcast=1;
 		break;
 	case QCS_MSG_INFO_REPLY:
@@ -260,5 +269,4 @@
 {
 	char ch;
-
 	assert( pmsg && pmsg_len && msg );
 
diff -NrU2 vqcc-gtk-0.5/src/libqcproto/p_qchat.h vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_qchat.h
--- vqcc-gtk-0.5/src/libqcproto/p_qchat.h	2004-12-22 20:51:04.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_qchat.h	2005-06-27 18:16:44.000000000 +0400
@@ -28,5 +28,5 @@
 #define P_QCHAT_H
 
-char * qcs__make_qchat_msg(const qcs_msg *, ssize_t *);
+char * qcs__make_qchat_msg(qcs_msg *, ssize_t *);
 int qcs__parse_qchat_msg(const char *, ssize_t, qcs_msg *);
 
diff -NrU2 vqcc-gtk-0.5/src/libqcproto/p_vypress.c vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_vypress.c
--- vqcc-gtk-0.5/src/libqcproto/p_vypress.c	2004-12-22 20:51:04.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_vypress.c	2005-06-27 18:19:34.000000000 +0400
@@ -46,5 +46,5 @@
 
 char * qcs__make_vypress_msg(
-	const qcs_msg * msg,
+	qcs_msg * msg,
 	ssize_t * pmsg_len )
 {
@@ -64,4 +64,5 @@
 		ADDCHAN(msg->chan);
 		ADDSTR(msg->text);
+		msg->broadcast=1;
 		break;
 		
@@ -89,5 +90,5 @@
 		break;
 	}
-
+	
 	/* allocate buffer for final version */
 	msg_buf = malloc(QCP_MAXUDPSIZE+10);
@@ -97,8 +98,9 @@
 		return NULL;
 	}
-
+	
+	
 	/* append msg id and register for duplicates */
 	qcs__generate_signature( msg_buf );
-
+	
 	/* build up final "version" */
 	memcpy(msg_buf+10, raw_msg, raw_len);
@@ -106,5 +108,5 @@
 		*pmsg_len = raw_len + 10;
 	}
-
+	
 	free(raw_msg);
 
diff -NrU2 vqcc-gtk-0.5/src/libqcproto/p_vypress.h vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_vypress.h
--- vqcc-gtk-0.5/src/libqcproto/p_vypress.h	2004-12-22 20:51:04.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/libqcproto/p_vypress.h	2005-06-27 18:19:43.000000000 +0400
@@ -28,5 +28,5 @@
 #define P_VYPRESS_H
 
-char * qcs__make_vypress_msg(const qcs_msg *, ssize_t *);
+char * qcs__make_vypress_msg(qcs_msg *, ssize_t *);
 int qcs__parse_vypress_msg(const char *, ssize_t, qcs_msg *);
 
diff -NrU2 vqcc-gtk-0.5/src/libqcproto/qcproto.h vqcc-gtk-0.5.1-shaman5/src/libqcproto/qcproto.h
--- vqcc-gtk-0.5/src/libqcproto/qcproto.h	2004-12-17 05:04:29.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/libqcproto/qcproto.h	2005-06-27 18:17:27.000000000 +0400
@@ -232,4 +232,5 @@
 };
 
+	
 /* qcs_msg:
  *	protocol message type */
@@ -239,4 +240,5 @@
 	unsigned long src_ip;	/* IP address of message source */
 	int uactive;		/* used to notify if the user is active */
+	int broadcast; 		/*  */
 	char * src;	/* src nickname */
 	char * dst;	/* dst nickname */
diff -NrU2 vqcc-gtk-0.5/src/main.h vqcc-gtk-0.5.1-shaman5/src/main.h
--- vqcc-gtk-0.5/src/main.h	2005-01-03 04:20:22.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/main.h	2005-04-07 23:34:17.000000000 +0400
@@ -92,4 +92,5 @@
 	EVENT_IFACE_USER_INFO_REQ,	/* p = user_id */
 	EVENT_IFACE_USER_MESSAGE_REQ,
+	EVENT_IFACE_USER_MASS_MESSAGE_REQ,
 	EVENT_IFACE_USER_BEEP_REQ,
 	EVENT_IFACE_USER_OPEN_REQ,
@@ -170,4 +171,5 @@
 	EVENT_MESSAGE	= 0x08000,
 	EVENT_MESSAGE_SEND,		/* p={uid, text}		*/
+	EVENT_MASS_MESSAGE_SEND,/* p={ text}		*/
 
 	EVENT_IDLE	= 0x10000,
@@ -212,3 +214,2 @@
 
 #endif /* #ifndef MAIN_H__ */
-
